// This example is not self-contained.
// It requires usage of the example driver specific to your platform.
// See the HAL documentation.

#include "src/bindings/hal_common.h"
#include "src/bindings/brick_hat_zero.h"

void check(int rc, const char *msg);
void example_setup(TF_HAL *hal);
void example_loop(TF_HAL *hal);

static TF_HATZero hz;

void example_setup(TF_HAL *hal) {
	// Create device object
	check(tf_hat_zero_create(&hz, NULL, hal), "create device object");

	// Get current voltage
	uint16_t voltage;
	check(tf_hat_zero_get_usb_voltage(&hz, &voltage), "get voltage");

	tf_hal_printf("Voltage: %d 1/%d V\n", voltage, 1000);
}

void example_loop(TF_HAL *hal) {
	// Poll for callbacks
	tf_hal_callback_tick(hal, 0);
}
